'use strict'

const test = require('tape')
const renderInfo = require('../src/print-info.js')
const estiloVersion = require('../package.json').version

const expected = `"
" schemeTest 2.1.0
" description d
" url u
" author: author a
" license: MIT
"
" Generated by Estilo ${estiloVersion}
" https://github.com/jacoborus/estilo

let g:colors_name="schemeTest"
hi clear
if exists("syntax_on")
  syntax reset
endif
if has("gui_running")
  set background=dark
endif\n\n`

test('renderInfo: with watermark', t => {
  let data = {
    author: 'author a',
    description: 'description d',
    license: 'MIT',
    url: 'url u',
    version: '2.1.0'
  }
  const theme = {
    name: 'schemeTest',
    background: 'dark'
  }
  t.is(renderInfo(data, theme), expected)
  t.end()
})
